Linux-libre 3.2-libre final, with backports for future respins of older releases.
[releases.git] / deblob-main
index 71840776c75f2fedd484c7550328ad4a69bba41d..1ea6a110dc8c16847ad26e6bbb9ab469bb4c81f3 100755 (executable)
@@ -1,6 +1,6 @@
 #! /bin/sh
 
-# Copyright (C) 2008, 2009 Alexandre Oliva <lxoliva@fsfla.org>
+# Copyright (C) 2008, 2009, 2010, 2011 Alexandre Oliva <lxoliva@fsfla.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,9 +17,9 @@
 # Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
 # USA
 
-# deblob.sh - prepare a linux-libre tarball out of a non-libre Linux
-# tarball.  It expects the Linux release (mver, say 2.6.25) as the
-# first argument, the libre sub-release (extra) as the second optional
+# deblob-main - prepare a linux-libre tarball out of a non-libre Linux
+# tarball.  It expects the Linux release (mver, say 3.0) as the first
+# argument, the libre sub-release (extra) as the second optional
 # argument, and the patch release (sver, say .13) as an optional third
 # argument.  mver and sver are pasted together to form kver.
 
 # yourself, because xdelta (unlike patches) is not reversible: the
 # removed bits are not present in it at all.
 
+# xdelta version 3 uses different command line syntax, and it switched
+# to the more standardized but less efficient vcdiff file format.
+# This script will also produce a vcdiff file if xdelta3 is present,
+# and it expects the xdelta program to use the version 1 syntax.
+
 # To enable you to check the differences between the tarballs, a patch
 # file is generated in linux-$kver-libre$extra.patch.  This patch file
 # contains the non-Free blobs, even though in reversed form, so its
 # distribution is discouraged.
 
+# The tar files and binary deltas are finally compressed with bzip2,
+# and optionally with lzip and xz too, if the compressors are
+# available.
+
 # At the end, the script attempts to generate a digital signature for
 # the newly-created tarball.  This is the last thing the script does,
 # so interrupting it at that point to skip the signing won't fail to
@@ -63,7 +72,7 @@ esac
 
 mver=$1 extra=$2 sver=$3
 kver=$mver$sver libre=libre$extra
-deblob= dir=`echo $0 | sed 's,/[^/]*$,,'`
+deblob= dir=`echo "$0" | sed 's,[^/]*$,,;s,^$,.,;s,/*$,,'`
 
 if test ! -f linux-$kver.tar.bz2; then
   echo linux-$kver.tar.bz2 does not exist >&2
@@ -93,50 +102,61 @@ else
   exit 1
 fi
 
-if test -f linux-$kver-$libre.tar.bz2; then
-  echo linux-$kver-$libre.tar.bz2 already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver.tar; then
-  echo linux-$kver.tar already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver-$libre.tar; then
-  echo linux-$kver-$libre.tar already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver-$libre.patch; then
-  echo linux-$kver-$libre.patch already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver-$libre.log; then
-  echo linux-$kver-$libre.log already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver-$libre.xdelta; then
-  echo linux-$kver-$libre.xdelta already exists >&2
-  exit 1
-fi
-
-if test -d linux-$kver; then
-  echo linux-$kver already exists >&2
-  exit 1
-fi
-
-if test -d linux-$kver-$libre; then
-  echo linux-$kver-$libre already exists >&2
-  exit 1
-fi
-
-if test -d orig-linux-$kver; then
-  echo orig-linux-$kver already exists >&2
-  exit 1
-fi
+cleanup=
+
+for f in \
+  linux-$kver-$libre.tar.bz2 \
+  linux-$kver-$libre.tar.bz2.asc \
+  linux-$kver-$libre.tar.bz2.sign \
+  linux-$kver-$libre.tar.xz \
+  linux-$kver-$libre.tar.xz.asc \
+  linux-$kver-$libre.tar.xz.sign \
+  linux-$kver-$libre.tar.lz \
+  linux-$kver-$libre.tar.lz.asc \
+  linux-$kver-$libre.tar.lz.sign \
+  linux-$kver.tar \
+  linux-$kver-$libre.tar \
+  linux-$kver-$libre.patch \
+  linux-$kver-$libre.log \
+  linux-$kver-$libre.vcdiff \
+  linux-$kver-$libre.vcdiff.bz2 \
+  linux-$kver-$libre.vcdiff.bz2.asc \
+  linux-$kver-$libre.vcdiff.bz2.sign \
+  linux-$kver-$libre.vcdiff.xz \
+  linux-$kver-$libre.vcdiff.xz.asc \
+  linux-$kver-$libre.vcdiff.xz.sign \
+  linux-$kver-$libre.vcdiff.lz \
+  linux-$kver-$libre.vcdiff.lz.asc \
+  linux-$kver-$libre.vcdiff.lz.sign \
+  linux-$kver-$libre.xdelta \
+  linux-$kver-$libre.xdelta.bz2 \
+  linux-$kver-$libre.xdelta.bz2.asc \
+  linux-$kver-$libre.xdelta.bz2.sign \
+  linux-$kver-$libre.xdelta.xz \
+  linux-$kver-$libre.xdelta.xz.asc \
+  linux-$kver-$libre.xdelta.xz.sign \
+  linux-$kver-$libre.xdelta.lz \
+  linux-$kver-$libre.xdelta.lz.asc \
+  linux-$kver-$libre.xdelta.lz.sign \
+; do
+  if test -f $f; then
+    echo $f already exists >&2
+    exit 1
+  fi
+  cleanup="$cleanup $f"
+done
+
+for d in \
+  linux-$kver \
+  linux-$kver-$libre \
+  orig-linux-$kver \
+; do
+  if test -d $d; then
+    echo $d already exists >&2
+    exit 1
+  fi
+  cleanup="$cleanup $d"
+done
 
 if test -f $dir/deblob-$kver; then
   if cmp $dir/deblob-$kver $deblob; then
@@ -162,7 +182,7 @@ else
   fi
 fi
 
-trap "status=$?; echo cleaning up...; rm -rf orig-linux-$kver linux-$kver linux-$kver-$libre linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.tar.bz2 linux-$kver-$libre.patch linux-$kver-$libre.xdelta; (exit $status); exit" 0 1 2 15
+trap "status=$?; echo cleaning up...; rm -rf $cleanup; (exit $status); exit" 0 1 2 15
 
 set -e
 
@@ -170,7 +190,7 @@ echo Uncompressing linux-$kver.tar.bz2 into linux-$kver.tar
 rm -rf linux-$kver linux-$kver.tar
 bunzip2 < linux-$kver.tar.bz2 > linux-$kver.tar
 
-echo Extracing linux-$kver.tar into linux-$kver
+echo Extracting linux-$kver.tar into linux-$kver
 tar -xf linux-$kver.tar
 rm -rf linux-$kver-$libre linux-$kver-$libre.tar
 
@@ -180,7 +200,7 @@ cp -lR linux-$kver/. linux-$kver-$libre
 
 rm -f linux-$kver-$libre.log linux-$kver-$libre.log.tmp
 echo Deblobbing within linux-$kver-$libre, saving output to linux-$kver-$libre.log
-# We can't just pipe deblob into tee, for then we fail to detect 
+# We can't just pipe deblob into tee, for then we fail to detect
 # error conditions.  Use file renaming to tell whether we succeeded.
 if (cd linux-$kver-$libre && /bin/sh ../$deblob $force) 2>&1; then
   mv linux-$kver-$libre.log.tmp linux-$kver-$libre.log
@@ -220,26 +240,50 @@ xargs tar --append -f linux-$kver-$libre.tar
 echo Wiping out extracted trees
 rm -rf linux-$kver orig-linux-$kver
 
+echo Creating vcdiff between linux-$kver.tar and linux-$kver-$libre.tar
+xdelta3 -e -9 -S djw -s linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.vcdiff || : # don't fail if xdelta3 is not present
+
 echo Creating xdelta between linux-$kver.tar and linux-$kver-$libre.tar
 xdelta delta -0 linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.xdelta || : # xdelta returns nonzero on success
 
-echo Compressing linux-$kver-$libre.tar and linux-$kver-$libre.xdelta
+echo Compressing binary deltas and linux-$kver-$libre.tar
 rm -f linux-$kver.tar
-bzip2 -9 linux-$kver-$libre.tar
+if test -f linux-$kver-$libre.vcdiff; then
+  bzip2 -k9 linux-$kver-$libre.vcdiff
+  xz -k9 linux-$kver-$libre.vcdiff || :
+  lzip -k9 linux-$kver-$libre.vcdiff || :
+  rm -f linux-$kver-$libre.vcdiff
+fi
 if test -f linux-$kver-$libre.xdelta; then
-  bzip2 -9 linux-$kver-$libre.xdelta
+  bzip2 -k9 linux-$kver-$libre.xdelta
+  xz -k9 linux-$kver-$libre.xdelta || :
+  lzip -k9 linux-$kver-$libre.xdelta || :
+  rm -f linux-$kver-$libre.xdelta
 fi
+bzip2 -k9 linux-$kver-$libre.tar
+xz -k9 linux-$kver-$libre.tar || :
+lzip -k9 linux-$kver-$libre.tar || :
+rm -f linux-$kver-$libre.tar
 
 trap "status=$?; (exit $status); exit" 0 1 2 15
 
 echo Done except for signing, feel free to interrupt
-gpg -a --detach-sign linux-$kver-$libre.tar.bz2
-mv linux-$kver-$libre.tar.bz2.asc linux-$kver-$libre.tar.bz2.sign
-
-if test -f linux-$kver-$libre.xdelta.bz2; then
-  gpg -a --detach-sign linux-$kver-$libre.xdelta.bz2
-  mv linux-$kver-$libre.xdelta.bz2.asc linux-$kver-$libre.xdelta.bz2.sign
-fi
+for f in \
+  linux-$kver-$libre.tar.bz2 \
+  linux-$kver-$libre.tar.xz \
+  linux-$kver-$libre.tar.lz \
+  linux-$kver-$libre.vcdiff.bz2 \
+  linux-$kver-$libre.vcdiff.xz \
+  linux-$kver-$libre.vcdiff.lz \
+  linux-$kver-$libre.xdelta.bz2 \
+  linux-$kver-$libre.xdelta.xz \
+  linux-$kver-$libre.xdelta.lz \
+; do
+  if test -f $f; then
+    gpg -a --detach-sign $f
+    mv $f.asc $f.sign
+  fi
+done
 
 echo All set, please review linux-$kver-$libre.patch